function E(u, e = "log", t, r = "color: inherit") {
  if (!("console" in window) || !window.console[e])
    return;
  const o = "Hawk (3.2.6)", l = `line-height: 1em;
            color: #fff;
            display: inline-block;
            line-height: 1em;
            background-color: rgba(0,0,0,.7);
            padding: 3px 5px;
            border-radius: 3px;
            margin-right: 2px`;
  try {
    ["time", "timeEnd"].includes(e) ? console[e](`( ${o} ) ${u}`) : t ? console[e](`%c${o}%c ${u} %o`, l, r, t) : console[e](`%c${o}%c ${u}`, l, r);
  } catch {
  }
}
class R {
  /**
   * Creates new Socket instance. Setup initial socket params.
   *
   * @param options — constructor options for catcher initialization
   */
  constructor({
    collectorEndpoint: e,
    // eslint-disable-next-line @typescript-eslint/no-empty-function, @typescript-eslint/no-unused-vars
    onMessage: t = (m) => {
    },
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onClose: r = () => {
    },
    // eslint-disable-next-line @typescript-eslint/no-empty-function
    onOpen: o = () => {
    },
    reconnectionAttempts: l = 5,
    reconnectionTimeout: g = 1e4
    // 10 * 1000 ms = 10 sec
  }) {
    this.url = e, this.onMessage = t, this.onClose = r, this.onOpen = o, this.reconnectionTimeout = g, this.reconnectionAttempts = l, this.eventsQueue = [], this.ws = null, this.init().then(() => {
      this.sendQueue();
    }).catch((m) => {
      E("WebSocket error", "error", m);
    });
  }
  /**
   * Send an event to the Collector
   *
   * @param message - event data in Hawk Format
   */
  async send(e) {
    if (this.ws === null)
      return this.eventsQueue.push(e), this.init();
    switch (this.ws.readyState) {
      case WebSocket.OPEN:
        return this.ws.send(JSON.stringify(e));
      case WebSocket.CLOSED:
        return this.eventsQueue.push(e), this.reconnect();
      case WebSocket.CONNECTING:
      case WebSocket.CLOSING:
        this.eventsQueue.push(e);
    }
  }
  /**
   * Create new WebSocket connection and setup event listeners
   */
  init() {
    return new Promise((e, t) => {
      this.ws = new WebSocket(this.url), typeof this.onMessage == "function" && (this.ws.onmessage = this.onMessage), this.ws.onclose = (r) => {
        typeof this.onClose == "function" && this.onClose(r);
      }, this.ws.onerror = (r) => {
        t(r);
      }, this.ws.onopen = (r) => {
        typeof this.onOpen == "function" && this.onOpen(r), e();
      };
    });
  }
  /**
   * Tries to reconnect to the server for specified number of times with the interval
   *
   * @param {boolean} [isForcedCall] - call function despite on timer
   * @returns {Promise<void>}
   */
  async reconnect(e = !1) {
    if (!(this.reconnectionTimer && !e)) {
      this.reconnectionTimer = null;
      try {
        await this.init(), E("Successfully reconnected.", "info");
      } catch {
        if (this.reconnectionAttempts--, this.reconnectionAttempts === 0)
          return;
        this.reconnectionTimer = setTimeout(() => {
          this.reconnect(!0);
        }, this.reconnectionTimeout);
      }
    }
  }
  /**
   * Sends all queued events one-by-one
   */
  sendQueue() {
    for (; this.eventsQueue.length; ) {
      const e = this.eventsQueue.shift();
      e && this.send(e).catch((t) => {
        E("WebSocket sending error", "error", t);
      });
    }
  }
}
const p = class p {
  /**
   * Apply sanitizing for array/object/primitives
   *
   * @param data - any object to sanitize
   * @param depth - current depth of recursion
   */
  static sanitize(e, t = 0) {
    return p.isArray(e) ? this.sanitizeArray(e, t + 1) : p.isElement(e) ? p.formatElement(e) : p.isClassPrototype(e) ? p.formatClassPrototype(e) : p.isClassInstance(e) ? p.formatClassInstance(e) : p.isObject(e) ? p.sanitizeObject(e, t + 1) : p.isString(e) ? p.trimString(e) : e;
  }
  /**
   * Apply sanitizing for each element of the array
   *
   * @param arr - array to sanitize
   * @param depth - current depth of recursion
   */
  static sanitizeArray(e, t) {
    const r = e.length;
    return r > p.maxArrayLength && (e = e.slice(0, p.maxArrayLength), e.push(`<${r - p.maxArrayLength} more items...>`)), e.map((o) => p.sanitize(o, t));
  }
  /**
   * Process object values recursive
   *
   * @param data - object to beautify
   * @param depth - current depth of recursion
   */
  static sanitizeObject(e, t) {
    if (t > p.maxDepth)
      return "<deep object>";
    if (Object.keys(e).length > p.maxObjectKeysCount)
      return "<big object>";
    const r = {};
    for (const o in e)
      Object.prototype.hasOwnProperty.call(e, o) && (r[o] = p.sanitize(e[o], t));
    return r;
  }
  /**
   * Check if passed variable is an object
   *
   * @param target - variable to check
   */
  static isObject(e) {
    return p.typeOf(e) === "object";
  }
  /**
   * Check if passed variable is an array
   *
   * @param target - variable to check
   */
  static isArray(e) {
    return Array.isArray(e);
  }
  /**
   * Check if passed variable is a not-constructed class
   *
   * @param target - variable to check
   */
  static isClassPrototype(e) {
    if (!e || !e.constructor)
      return !1;
    const t = e.constructor.toString();
    return t.includes("[native code]") && t.includes("Function");
  }
  /**
   * Check if passed variable is a constructed class instance
   *
   * @param target - variable to check
   */
  static isClassInstance(e) {
    return e && e.constructor && /^class \S+ {/.test(e.constructor.toString());
  }
  /**
   * Check if passed variable is a string
   *
   * @param target - variable to check
   */
  static isString(e) {
    return typeof e == "string";
  }
  /**
   * Return string representation of the object type
   *
   * @param object - object to get type
   */
  static typeOf(e) {
    return Object.prototype.toString.call(e).match(/\s([a-zA-Z]+)/)[1].toLowerCase();
  }
  /**
   * Check if passed variable is an HTML Element
   *
   * @param target - variable to check
   */
  static isElement(e) {
    return e instanceof Element;
  }
  /**
   * Return name of a passed class
   *
   * @param target - not-constructed class
   */
  static getClassNameByPrototype(e) {
    return e.name;
  }
  /**
   * Return name of a class by an instance
   *
   * @param target - instance of some class
   */
  static getClassNameByInstance(e) {
    return p.getClassNameByPrototype(e.constructor);
  }
  /**
   * Trim string if it reaches max length
   *
   * @param target - string to check
   */
  static trimString(e) {
    return e.length > p.maxStringLen ? e.substr(0, p.maxStringLen) + "…" : e;
  }
  /**
   * Represent HTML Element as string with it outer-html
   * HTMLDivElement -> "<div ...></div>"
   *
   * @param target - variable to format
   */
  static formatElement(e) {
    return e.innerHTML ? e.outerHTML.replace(e.innerHTML, "…") : e.outerHTML;
  }
  /**
   * Represent not-constructed class as "<class SomeClass>"
   *
   * @param target - class to format
   */
  static formatClassPrototype(e) {
    return `<instance of ${p.getClassNameByPrototype(e)}>`;
  }
  /**
   * Represent a some class instance as a "<instance of SomeClass>"
   *
   * @param target - class instance to format
   */
  static formatClassInstance(e) {
    return `<class ${p.getClassNameByInstance(e)}>`;
  }
};
p.maxStringLen = 200, p.maxObjectKeysCount = 20, p.maxDepth = 5, p.maxArrayLength = 10;
let v = p;
var $ = typeof globalThis < "u" ? globalThis : typeof window < "u" ? window : typeof global < "u" ? global : typeof self < "u" ? self : {};
function V(u) {
  return u && u.__esModule && Object.prototype.hasOwnProperty.call(u, "default") ? u.default : u;
}
var T = { exports: {} }, O = { exports: {} }, N;
function M() {
  return N || (N = 1, function(u, e) {
    (function(t, r) {
      u.exports = r();
    })($, function() {
      function t(s) {
        return !isNaN(parseFloat(s)) && isFinite(s);
      }
      function r(s) {
        return s.charAt(0).toUpperCase() + s.substring(1);
      }
      function o(s) {
        return function() {
          return this[s];
        };
      }
      var l = ["isConstructor", "isEval", "isNative", "isToplevel"], g = ["columnNumber", "lineNumber"], m = ["fileName", "functionName", "source"], c = ["args"], b = ["evalOrigin"], n = l.concat(g, m, c, b);
      function i(s) {
        if (s)
          for (var f = 0; f < n.length; f++)
            s[n[f]] !== void 0 && this["set" + r(n[f])](s[n[f]]);
      }
      i.prototype = {
        getArgs: function() {
          return this.args;
        },
        setArgs: function(s) {
          if (Object.prototype.toString.call(s) !== "[object Array]")
            throw new TypeError("Args must be an Array");
          this.args = s;
        },
        getEvalOrigin: function() {
          return this.evalOrigin;
        },
        setEvalOrigin: function(s) {
          if (s instanceof i)
            this.evalOrigin = s;
          else if (s instanceof Object)
            this.evalOrigin = new i(s);
          else
            throw new TypeError("Eval Origin must be an Object or StackFrame");
        },
        toString: function() {
          var s = this.getFileName() || "", f = this.getLineNumber() || "", y = this.getColumnNumber() || "", w = this.getFunctionName() || "";
          return this.getIsEval() ? s ? "[eval] (" + s + ":" + f + ":" + y + ")" : "[eval]:" + f + ":" + y : w ? w + " (" + s + ":" + f + ":" + y + ")" : s + ":" + f + ":" + y;
        }
      }, i.fromString = function(f) {
        var y = f.indexOf("("), w = f.lastIndexOf(")"), S = f.substring(0, y), k = f.substring(y + 1, w).split(","), A = f.substring(w + 1);
        if (A.indexOf("@") === 0)
          var C = /@(.+?)(?::(\d+))?(?::(\d+))?$/.exec(A, ""), I = C[1], F = C[2], H = C[3];
        return new i({
          functionName: S,
          args: k || void 0,
          fileName: I,
          lineNumber: F || void 0,
          columnNumber: H || void 0
        });
      };
      for (var a = 0; a < l.length; a++)
        i.prototype["get" + r(l[a])] = o(l[a]), i.prototype["set" + r(l[a])] = /* @__PURE__ */ function(s) {
          return function(f) {
            this[s] = !!f;
          };
        }(l[a]);
      for (var h = 0; h < g.length; h++)
        i.prototype["get" + r(g[h])] = o(g[h]), i.prototype["set" + r(g[h])] = /* @__PURE__ */ function(s) {
          return function(f) {
            if (!t(f))
              throw new TypeError(s + " must be a Number");
            this[s] = Number(f);
          };
        }(g[h]);
      for (var d = 0; d < m.length; d++)
        i.prototype["get" + r(m[d])] = o(m[d]), i.prototype["set" + r(m[d])] = /* @__PURE__ */ function(s) {
          return function(f) {
            this[s] = String(f);
          };
        }(m[d]);
      return i;
    });
  }(O)), O.exports;
}
(function(u, e) {
  (function(t, r) {
    u.exports = r(M());
  })($, function(r) {
    var o = /(^|@)\S+:\d+/, l = /^\s*at .*(\S+:\d+|\(native\))/m, g = /^(eval@)?(\[native code])?$/;
    return {
      /**
       * Given an Error object, extract the most information from it.
       *
       * @param {Error} error object
       * @return {Array} of StackFrames
       */
      parse: function(c) {
        if (typeof c.stacktrace < "u" || typeof c["opera#sourceloc"] < "u")
          return this.parseOpera(c);
        if (c.stack && c.stack.match(l))
          return this.parseV8OrIE(c);
        if (c.stack)
          return this.parseFFOrSafari(c);
        throw new Error("Cannot parse given Error object");
      },
      // Separate line and column numbers from a string of the form: (URI:Line:Column)
      extractLocation: function(c) {
        if (c.indexOf(":") === -1)
          return [c];
        var b = /(.+?)(?::(\d+))?(?::(\d+))?$/, n = b.exec(c.replace(/[()]/g, ""));
        return [n[1], n[2] || void 0, n[3] || void 0];
      },
      parseV8OrIE: function(c) {
        var b = c.stack.split(`
`).filter(function(n) {
          return !!n.match(l);
        }, this);
        return b.map(function(n) {
          n.indexOf("(eval ") > -1 && (n = n.replace(/eval code/g, "eval").replace(/(\(eval at [^()]*)|(,.*$)/g, ""));
          var i = n.replace(/^\s+/, "").replace(/\(eval code/g, "(").replace(/^.*?\s+/, ""), a = i.match(/ (\(.+\)$)/);
          i = a ? i.replace(a[0], "") : i;
          var h = this.extractLocation(a ? a[1] : i), d = a && i || void 0, s = ["eval", "<anonymous>"].indexOf(h[0]) > -1 ? void 0 : h[0];
          return new r({
            functionName: d,
            fileName: s,
            lineNumber: h[1],
            columnNumber: h[2],
            source: n
          });
        }, this);
      },
      parseFFOrSafari: function(c) {
        var b = c.stack.split(`
`).filter(function(n) {
          return !n.match(g);
        }, this);
        return b.map(function(n) {
          if (n.indexOf(" > eval") > -1 && (n = n.replace(/ line (\d+)(?: > eval line \d+)* > eval:\d+:\d+/g, ":$1")), n.indexOf("@") === -1 && n.indexOf(":") === -1)
            return new r({
              functionName: n
            });
          var i = /((.*".+"[^@]*)?[^@]*)(?:@)/, a = n.match(i), h = a && a[1] ? a[1] : void 0, d = this.extractLocation(n.replace(i, ""));
          return new r({
            functionName: h,
            fileName: d[0],
            lineNumber: d[1],
            columnNumber: d[2],
            source: n
          });
        }, this);
      },
      parseOpera: function(c) {
        return !c.stacktrace || c.message.indexOf(`
`) > -1 && c.message.split(`
`).length > c.stacktrace.split(`
`).length ? this.parseOpera9(c) : c.stack ? this.parseOpera11(c) : this.parseOpera10(c);
      },
      parseOpera9: function(c) {
        for (var b = /Line (\d+).*script (?:in )?(\S+)/i, n = c.message.split(`
`), i = [], a = 2, h = n.length; a < h; a += 2) {
          var d = b.exec(n[a]);
          d && i.push(new r({
            fileName: d[2],
            lineNumber: d[1],
            source: n[a]
          }));
        }
        return i;
      },
      parseOpera10: function(c) {
        for (var b = /Line (\d+).*script (?:in )?(\S+)(?:: In function (\S+))?$/i, n = c.stacktrace.split(`
`), i = [], a = 0, h = n.length; a < h; a += 2) {
          var d = b.exec(n[a]);
          d && i.push(
            new r({
              functionName: d[3] || void 0,
              fileName: d[2],
              lineNumber: d[1],
              source: n[a]
            })
          );
        }
        return i;
      },
      // Opera 10.65+ Error.stack very similar to FF/Safari
      parseOpera11: function(c) {
        var b = c.stack.split(`
`).filter(function(n) {
          return !!n.match(o) && !n.match(/^Error created at/);
        }, this);
        return b.map(function(n) {
          var i = n.split("@"), a = this.extractLocation(i.pop()), h = i.shift() || "", d = h.replace(/<anonymous function(: (\w+))?>/, "$2").replace(/\([^)]*\)/g, "") || void 0, s;
          h.match(/\(([^)]*)\)/) && (s = h.replace(/^[^(]+\(([^)]*)\)$/, "$1"));
          var f = s === void 0 || s === "[arguments not available]" ? void 0 : s.split(",");
          return new r({
            functionName: d,
            args: f,
            fileName: a[0],
            lineNumber: a[1],
            columnNumber: a[2],
            source: n
          });
        }, this);
      }
    };
  });
})(T);
var G = T.exports;
const D = /* @__PURE__ */ V(G);
function U(u, e) {
  const t = new AbortController(), r = t.signal, o = fetch(u, {
    signal: r
  }), l = setTimeout(() => {
    t.abort(), E("Request is too long, aborting...", "log", u);
  }, e);
  return o.then((g) => (clearTimeout(l), g));
}
class W {
  constructor() {
    this.sourceFilesCache = {};
  }
  /**
   * Parse Error stack string and return useful information about an Error
   *
   * @param error - event from which to get backtrace
   */
  async parse(e) {
    const t = D.parse(e);
    return Promise.all(t.map(async (r) => {
      const o = await this.extractSourceCode(r);
      return {
        file: r.fileName ?? "",
        line: r.lineNumber ?? 0,
        column: r.columnNumber,
        sourceCode: o !== null ? o : void 0,
        function: r.functionName,
        arguments: r.args
      };
    }));
  }
  /**
   * Extract 5 lines below and above the error's line
   *
   * @param {StackFrame} frame — information about backtrace item
   */
  async extractSourceCode(e) {
    try {
      if (!e.fileName || !this.isValidUrl(e.fileName) || e.columnNumber && e.columnNumber > 200)
        return null;
      const r = await this.loadSourceFile(e.fileName);
      if (!r)
        return null;
      const o = r.split(`
`), l = e.lineNumber ? e.lineNumber - 1 : 0, g = 5, m = Math.max(0, l - g), c = Math.min(o.length - 1, l + g + 1), b = [];
      let n = 1;
      return o.slice(m, c).forEach((i) => {
        if (i.length > 200)
          return null;
        b.push({
          line: m + n,
          content: i
        }), n += 1;
      }), b;
    } catch (r) {
      return console.warn("Hawk JS SDK: Can not extract source code. Please, report this issue: https://github.com/codex-team/hawk.javascript/issues/new", r), null;
    }
  }
  /**
   * Check if string is a valid URL
   *
   * @param string - string with URL to check
   */
  isValidUrl(e) {
    try {
      return !!new URL(e);
    } catch {
      return !1;
    }
  }
  /**
   * Downloads source file
   *
   * @param {string} fileName - name of file to download
   */
  async loadSourceFile(e) {
    if (this.sourceFilesCache[e] !== void 0)
      return this.sourceFilesCache[e];
    try {
      if (this.sourceFilesCache[e] = U(e, 2e3).then((t) => t.text()), Object.keys(this.sourceFilesCache).length > 10) {
        const t = this.sourceFilesCache[e];
        this.sourceFilesCache = {}, this.sourceFilesCache[e] = t;
      }
      return await this.sourceFilesCache[e];
    } catch {
      return E("Can not load source file. Skipping..."), null;
    }
  }
}
class B {
  /**
   * Set up a new vue app
   *
   * @param vue - Vue app to handle
   * @param callback - callback that accepts new error
   * @param options - additional options
   */
  constructor(e, t, r) {
    this.vue = e, this.existedHandler = e.config.errorHandler, this.callback = t, r.disableVueErrorHandler !== !0 && this.setupHandler();
  }
  /**
   * Extract additional useful information from the Vue app
   *
   * Can be used outside of this class, for example, by Nuxt integration
   *
   * @param vm - component instance
   * @param info - a Vue-specific error info, e.g. which lifecycle hook the error was found in.
   */
  spoilAddons(e, t) {
    return e.$ !== void 0 ? this.spoilAddonsFromVue3(e, t) : this.spoilAddonsFromVue2(e, t);
  }
  /**
   * Setups event handlers for Vue.js instance
   */
  setupHandler() {
    this.vue.config.errorHandler = /**
    * Vue app error handler
    *
    * @see https://vuejs.org/v2/api/#errorHandler
    * @param err - error thrown
    * @param vm - vue VM
    * @param info - a Vue-specific error info, e.g. which lifecycle hook the error was found in.
    */
    (e, t, r) => {
      typeof this.existedHandler == "function" && this.existedHandler.call(this.vue, e, t, r);
      const o = this.spoilAddons(t, r);
      this.callback(e, o), this.printError(e, r, o.component);
    };
  }
  /**
   * Extract additional useful information from the Vue 2 app
   *
   * @param vm - component instance
   * @param info - which lifecycle hook the error was found in.
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  spoilAddonsFromVue2(e, t) {
    const r = {
      lifecycle: t,
      component: null
    };
    return e.$root === e ? r.component = e.$el.outerHTML.replace(/>.*/, ">") + " (root)" : r.component = "<" + (e._isVue ? e.$options.name || e.$options._componentTag : e.name) + ">", e.$options && e.$options.propsData && (r.props = e.$options.propsData), e._data && (r.data = {}, Object.entries(e._data).forEach(([o, l]) => {
      r.data[o] = l;
    })), e._computedWatchers && (r.computed = {}, Object.entries(e._computedWatchers).forEach(([o, l]) => {
      r.computed[o] = l.value;
    })), r;
  }
  /**
   * Extract additional useful information from the Vue 3 app
   *
   * @param vm - component instance
   * @param info - which lifecycle hook the error was found in.
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  spoilAddonsFromVue3(e, t) {
    const r = {
      lifecycle: this.getRuntimeErrorSourceByCode(t),
      component: null
    };
    return e.$options !== void 0 && (r.component = `<${e.$options.__name || e.$options.name || e.$options._componentTag || "Anonymous"}>`), Object.keys(e.$props).length && (r.props = e.$props), r;
  }
  /**
   * In production, the error code is a link with reference to doc.
   * This method returns the error message by the code extracted from the link
   *
   * @param code - Error source info (3rd argument of the vue:error hook)
   * https://vuejs.org/api/composition-api-lifecycle.html#onerrorcaptured
   */
  getRuntimeErrorSourceByCode(e) {
    if (!e.includes("https://vuejs.org/error-reference/#runtime-"))
      return e;
    const t = e.split("https://vuejs.org/error-reference/#runtime-"), r = t[t.length - 1];
    return (/* @__PURE__ */ new Map([
      ["0", "setup function"],
      ["1", "render function"],
      ["2", "watcher getter"],
      ["3", "watcher callback"],
      ["4", "watcher cleanup function"],
      ["5", "native event handler"],
      ["6", "component event handler"],
      ["7", "vnode hook"],
      ["8", "directive hook"],
      ["9", "transition hook"],
      ["10", "app errorHandler"],
      ["11", "app warnHandler"],
      ["12", "ref function"],
      ["13", "async component loader"],
      ["14", "scheduler flush"],
      ["15", "component update"],
      ["16", "app unmount cleanup function"],
      ["sp", "serverPrefetch hook"],
      ["bc", "beforeCreate hook"],
      ["c", "created hook"],
      ["bm", "beforeMount hook"],
      ["m", "mounted hook"],
      ["bu", "beforeUpdate hook"],
      ["u", "updated"],
      ["bum", "beforeUnmount hook"],
      ["um", "unmounted hook"],
      ["a", "activated hook"],
      ["da", "deactivated hook"],
      ["ec", "errorCaptured hook"],
      ["rtc", "renderTracked hook"],
      ["rtg", "renderTriggered hook"]
    ])).get(r) || e;
  }
  /**
   * Write error to the console
   *
   * @param err - error to print
   * @param info - a Vue-specific error info, e.g. which lifecycle hook the error was found in.
   * @param component - where error was occurred
   */
  printError(e, t, r) {
    const o = this.getRuntimeErrorSourceByCode(t);
    if (r === null) {
      console.error(`${o}`, e);
      return;
    }
    console.error(`${r} @ ${o}`, e);
  }
}
function z() {
  const u = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
  let e = new Uint8Array(40);
  return window.crypto.getRandomValues(e), e = e.map((t) => u.charCodeAt(t % u.length)), String.fromCharCode.apply(null, e);
}
class x extends Error {
  /**
   * @param message - error message
   */
  constructor(e) {
    super(e), this.name = "EventRejectedError";
  }
}
const P = Symbol("__hawk_processed__");
function Q(u) {
  return typeof u != "object" || u === null ? !1 : u[P] === !0;
}
function J(u) {
  try {
    if (typeof u != "object" || u === null)
      return;
    Object.defineProperty(u, P, {
      enumerable: !1,
      // Prevent from beight collected by Hawk
      value: !0,
      writable: !0,
      configurable: !0
    });
  } catch (e) {
    E("Failed to mark error as processed", "error", e);
  }
}
function L(u) {
  return function(e, t) {
    if (typeof (t == null ? void 0 : t.toJSON) == "function" && (t = t.toJSON()), !(t !== null && typeof t == "object"))
      return t;
    if (u.has(t))
      return "[Circular]";
    u.add(t);
    const r = Array.isArray(t) ? [] : {};
    for (const [o, l] of Object.entries(t))
      r[o] = L(u)(o, l);
    return u.delete(t), r;
  };
}
function K(u, { indentation: e } = {}) {
  return JSON.stringify(u, L(/* @__PURE__ */ new WeakSet()), e);
}
function X() {
  const e = [];
  let t = !1;
  function r(n) {
    return typeof n == "string" ? n : typeof n == "number" || typeof n == "boolean" ? String(n) : K(n);
  }
  function o(n) {
    if (n.length === 0)
      return {
        message: "",
        styles: []
      };
    const i = n[0];
    if (typeof i != "string" || !i.includes("%c"))
      return {
        message: n.map((f) => {
          try {
            return r(f);
          } catch (y) {
            return "[Error stringifying argument: " + (y instanceof Error ? y.message : String(y)) + "]";
          }
        }).join(" "),
        styles: []
      };
    const a = n[0], h = [];
    let d = 0;
    for (let f = 1; f < n.length; f++) {
      const y = n[f];
      typeof y == "string" && a.indexOf("%c", d) !== -1 && (h.push(y), d = a.indexOf("%c", d) + 2);
    }
    const s = n.slice(h.length + 1).map((f) => {
      try {
        return r(f);
      } catch (y) {
        return "[Error stringifying argument: " + (y instanceof Error ? y.message : String(y)) + "]";
      }
    }).join(" ");
    return {
      message: a + (s ? " " + s : ""),
      styles: h
    };
  }
  function l(n) {
    e.length >= 20 && e.shift(), e.push(n);
  }
  function g(n) {
    var i, a, h, d, s;
    return n instanceof ErrorEvent ? {
      method: "error",
      timestamp: /* @__PURE__ */ new Date(),
      type: ((i = n.error) == null ? void 0 : i.name) || "Error",
      message: ((a = n.error) == null ? void 0 : a.message) || n.message,
      stack: ((h = n.error) == null ? void 0 : h.stack) || "",
      fileLine: n.filename ? `${n.filename}:${n.lineno}:${n.colno}` : ""
    } : {
      method: "error",
      timestamp: /* @__PURE__ */ new Date(),
      type: "UnhandledRejection",
      message: ((d = n.reason) == null ? void 0 : d.message) || String(n.reason),
      stack: ((s = n.reason) == null ? void 0 : s.stack) || "",
      fileLine: ""
    };
  }
  function m() {
    if (t)
      return;
    t = !0, ["log", "warn", "error", "info", "debug"].forEach(function(a) {
      if (typeof window.console[a] != "function")
        return;
      const h = window.console[a].bind(window.console);
      window.console[a] = function(...d) {
        var S, k;
        const s = ((S = new Error().stack) == null ? void 0 : S.split(`
`).slice(2).join(`
`)) || "", { message: f, styles: y } = o(d), w = {
          method: a,
          timestamp: /* @__PURE__ */ new Date(),
          type: a,
          message: f,
          stack: s,
          fileLine: (k = s.split(`
`)[0]) == null ? void 0 : k.trim(),
          styles: y
        };
        l(w), h(...d);
      };
    });
  }
  function c(n) {
    const i = g(n);
    l(i);
  }
  function b() {
    return [...e];
  }
  return {
    initConsoleCatcher: m,
    addErrorEvent: c,
    getConsoleLogStack: b
  };
}
const _ = X(), { initConsoleCatcher: q, getConsoleLogStack: Y, addErrorEvent: Z } = _;
class j {
  /**
   * Catcher constructor
   *
   * @param {HawkInitialSettings|string} settings - If settings is a string, it means an Integration Token
   */
  constructor(e) {
    if (this.version = "3.2.6", this.vue = null, this.type = "errors/javascript", this.stackParser = new W(), this.disableVueErrorHandler = !1, typeof e == "string" && (e = {
      token: e
    }), this.token = e.token, this.debug = e.debug || !1, this.release = e.release, this.user = e.user || j.getGeneratedUser(), this.context = e.context || void 0, this.beforeSend = e.beforeSend, this.disableVueErrorHandler = e.disableVueErrorHandler ?? !1, this.consoleTracking = e.consoleTracking ?? !0, !this.token) {
      E(
        "Integration Token is missed. You can get it on https://hawk.so at Project Settings.",
        "warn"
      );
      return;
    }
    this.transport = new R({
      collectorEndpoint: e.collectorEndpoint || `wss://${this.getIntegrationId()}.k1.hawk.so:443/ws`,
      reconnectionAttempts: e.reconnectionAttempts,
      reconnectionTimeout: e.reconnectionTimeout,
      onClose() {
        E(
          "Connection lost. Connection will be restored when new errors occurred",
          "info"
        );
      }
    }), this.consoleTracking && q(), e.disableGlobalErrorsHandling || this.initGlobalHandlers(), e.vue && this.connectVue(e.vue);
  }
  /**
   * Generates user if no one provided via HawkCatcher settings
   * After generating, stores user for feature requests
   */
  static getGeneratedUser() {
    let e;
    const t = "hawk-user-id", r = localStorage.getItem(t);
    return r ? e = r : (e = z(), localStorage.setItem(t, e)), {
      id: e
    };
  }
  /**
   * Send test event from client
   */
  test() {
    const e = new Error("Hawk JavaScript Catcher test message.");
    this.send(e);
  }
  /**
   * Public method for manual sending messages to the Hawk
   * Can be called in user's try-catch blocks or by other custom logic
   *
   * @param message - what to send
   * @param [context] - any additional data to send
   */
  send(e, t) {
    this.formatAndSend(e, void 0, t);
  }
  /**
   * Method for Frameworks SDK using own error handlers.
   * Allows to send errors to Hawk with additional Frameworks data (addons)
   *
   * @param error - error to send
   * @param [addons] - framework-specific data, can be undefined
   */
  // eslint-disable-next-line @typescript-eslint/no-explicit-any
  captureError(e, t) {
    this.formatAndSend(e, t);
  }
  /**
   * Add error handing to the passed Vue app
   *
   * @param vue - Vue app
   */
  connectVue(e) {
    this.vue = new B(e, (t, r) => {
      this.formatAndSend(t, {
        vue: r
      });
    }, {
      disableVueErrorHandler: this.disableVueErrorHandler
    });
  }
  /**
   * Init global errors handler
   */
  initGlobalHandlers() {
    window.addEventListener("error", (e) => this.handleEvent(e)), window.addEventListener("unhandledrejection", (e) => this.handleEvent(e));
  }
  /**
   * Handles the event and sends it to the server
   *
   * @param {ErrorEvent|PromiseRejectionEvent} event — (!) both for Error and Promise Rejection
   */
  async handleEvent(e) {
    this.consoleTracking && Z(e);
    let t = e.error || e.reason;
    e instanceof ErrorEvent && t === void 0 && (t = e.message), this.formatAndSend(t);
  }
  /**
   * Format and send an error
   *
   * @param error - error to send
   * @param integrationAddons - addons spoiled by Integration
   * @param context - any additional data passed by user
   */
  async formatAndSend(e, t, r) {
    try {
      if (Q(e))
        return;
      J(e);
      const l = await this.prepareErrorFormatted(e, r);
      t && this.appendIntegrationAddons(l, v.sanitize(t)), this.sendErrorFormatted(l);
    } catch (o) {
      if (o instanceof x)
        return;
      E("Unable to send error. Seems like it is Hawk internal bug. Please, report it here: https://github.com/codex-team/hawk.javascript/issues/new", "warn", o);
    }
  }
  /**
   * Sends formatted HawkEvent to the Collector
   *
   * @param errorFormatted - formatted error to send
   */
  sendErrorFormatted(e) {
    this.transport.send(e).catch((t) => {
      E("WebSocket sending error", "error", t);
    });
  }
  /**
   * Formats the event
   *
   * @param error - error to format
   * @param context - any additional data passed by user
   */
  async prepareErrorFormatted(e, t) {
    let r = {
      title: this.getTitle(e),
      type: this.getType(e),
      release: this.getRelease(),
      context: this.getContext(t),
      user: this.getUser(),
      addons: this.getAddons(e),
      backtrace: await this.getBacktrace(e),
      catcherVersion: this.version
    };
    if (typeof this.beforeSend == "function") {
      const o = this.beforeSend(r);
      if (o === !1)
        throw new x("Event rejected by beforeSend method.");
      r = o;
    }
    return {
      token: this.token,
      catcherType: this.type,
      payload: r
    };
  }
  /**
   * Return event title
   *
   * @param error - event from which to get the title
   */
  getTitle(e) {
    return e instanceof Error ? e.message : e.toString();
  }
  /**
   * Return event type: TypeError, ReferenceError etc
   *
   * @param error - caught error
   */
  getType(e) {
    return e instanceof Error ? e.name : null;
  }
  /**
   * Release version
   */
  getRelease() {
    return this.release || null;
  }
  /**
   * Returns integration id from integration token
   */
  getIntegrationId() {
    try {
      const e = JSON.parse(atob(this.token)), { integrationId: t } = e;
      if (!t || t === "")
        throw new Error();
      return t;
    } catch {
      throw new Error("Invalid integration token.");
    }
  }
  /**
   * Collects additional information
   *
   * @param context - any additional data passed by user
   */
  getContext(e) {
    const t = {};
    return this.context !== void 0 && Object.assign(t, this.context), e !== void 0 && Object.assign(t, e), v.sanitize(t);
  }
  /**
   * Current authenticated user
   */
  getUser() {
    return this.user || null;
  }
  /**
   * Get parameters
   */
  getGetParams() {
    const e = window.location.search.substr(1);
    return e ? e.split("&").reduce((r, o) => {
      const [l, g] = o.split("=");
      return r[l] = g, r;
    }, {}) : null;
  }
  /**
   * Return parsed backtrace information
   *
   * @param error - event from which to get backtrace
   */
  async getBacktrace(e) {
    if (!(e instanceof Error))
      return null;
    try {
      return await this.stackParser.parse(e);
    } catch (r) {
      return E("Can not parse stack:", "warn", r), null;
    }
  }
  /**
   * Return some details
   *
   * @param {Error|string} error — caught error
   */
  getAddons(e) {
    const { innerWidth: t, innerHeight: r } = window, o = window.navigator.userAgent, l = window.location.href, g = this.getGetParams(), m = this.consoleTracking && Y(), c = {
      window: {
        innerWidth: t,
        innerHeight: r
      },
      userAgent: o,
      url: l
    };
    return g && (c.get = g), this.debug && (c.RAW_EVENT_DATA = this.getRawData(e)), m && m.length > 0 && (c.consoleOutput = m), c;
  }
  /**
   * Compose raw data object
   *
   * @param {Error|string} error — caught error
   */
  getRawData(e) {
    if (e instanceof Error)
      return {
        name: e.name,
        message: e.message,
        stack: e.stack ?? ""
      };
  }
  /**
   * Extend addons object with addons spoiled by integration
   * This method mutates original event
   *
   * @param errorFormatted - Hawk event prepared for sending
   * @param integrationAddons - extra addons
   */
  appendIntegrationAddons(e, t) {
    Object.assign(e.payload.addons, t);
  }
}
export {
  j as default
};
