import { BacktraceFrame } from '@hawk.so/types';
/**
 * This module prepares parsed backtrace
 */
export default class StackParser {
    /**
     * Prevents loading one file several times
     * name -> content
     */
    private sourceFilesCache;
    /**
     * Parse Error stack string and return useful information about an Error
     *
     * @param error - event from which to get backtrace
     */
    parse(error: Error): Promise<BacktraceFrame[]>;
    /**
     * Extract 5 lines below and above the error's line
     *
     * @param {StackFrame} frame — information about backtrace item
     */
    private extractSourceCode;
    /**
     * Check if string is a valid URL
     *
     * @param string - string with URL to check
     */
    private isValidUrl;
    /**
     * Downloads source file
     *
     * @param {string} fileName - name of file to download
     */
    private loadSourceFile;
}
