/**
 * Check if the error has alrady been sent to Hawk.
 *
 * Motivation:
 * Some integrations may catch errors on their own side and then normally re-throw them down.
 * In this case, Hawk will catch the error again.
 * We need to prevent this from happening.
 *
 * @param error - error object
 */
export declare function isErrorProcessed(error: unknown): boolean;
/**
 * Add non-enumerable property to the error object to mark it as processed.
 *
 * @param error - error object
 */
export declare function markErrorAsProcessed(error: unknown): void;
